//### This file created by BYACC 1.8(/Java extension  1.13)
//### Java capabilities added 7 Jan 97, Bob Jamison
//### Updated : 27 Nov 97  -- Bob Jamison, Joe Nieten
//###           01 Jan 98  -- Bob Jamison -- fixed generic semantic constructor
//###           01 Jun 99  -- Bob Jamison -- added Runnable support
//###           06 Aug 00  -- Bob Jamison -- made state variables class-global
//###           03 Jan 01  -- Bob Jamison -- improved flags, tracing
//###           16 May 01  -- Bob Jamison -- added custom stack sizing
//###           04 Mar 02  -- Yuval Oren  -- improved java performance, added options
//###           14 Mar 02  -- Tomas Hurka -- -d support, static initializer workaround
//### Please send bug reports to tom@hukatronic.cz
//### static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";



package com.thoughtworks.qdox.parser.impl;



//#line 2 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
import com.thoughtworks.qdox.parser.*;
import com.thoughtworks.qdox.parser.structs.*;
import com.thoughtworks.qdox.model.*;
import com.thoughtworks.qdox.model.annotation.*;
import java.io.IOException;
import java.util.LinkedList;
import java.util.ArrayList;
import java.util.List;
import java.util.Stack;
//#line 27 "Parser.java"




public class Parser
{

boolean yydebug;        //do I want debug output?
int yynerrs;            //number of errors so far
int yyerrflag;          //was there an error?
int yychar;             //the current working character

//########## MESSAGES ##########
//###############################################################
// method: debug
//###############################################################
void debug(String msg)
{
  if (yydebug)
    System.out.println(msg);
}

//########## STATE STACK ##########
final static int YYSTACKSIZE = 500;  //maximum stack size
int statestk[] = new int[YYSTACKSIZE]; //state stack
int stateptr;
int stateptrmax;                     //highest index of stackptr
int statemax;                        //state when highest index reached
//###############################################################
// methods: state stack push,pop,drop,peek
//###############################################################
final void state_push(int state)
{
  try {
		stateptr++;
		statestk[stateptr]=state;
	 }
	 catch (ArrayIndexOutOfBoundsException e) {
     int oldsize = statestk.length;
     int newsize = oldsize * 2;
     int[] newstack = new int[newsize];
     System.arraycopy(statestk,0,newstack,0,oldsize);
     statestk = newstack;
     statestk[stateptr]=state;
  }
}
final int state_pop()
{
  return statestk[stateptr--];
}
final void state_drop(int cnt)
{
  stateptr -= cnt; 
}
final int state_peek(int relative)
{
  return statestk[stateptr-relative];
}
//###############################################################
// method: init_stacks : allocate and prepare stacks
//###############################################################
final boolean init_stacks()
{
  stateptr = -1;
  val_init();
  return true;
}
//###############################################################
// method: dump_stacks : show n levels of the stacks
//###############################################################
void dump_stacks(int count)
{
int i;
  System.out.println("=index==state====value=     s:"+stateptr+"  v:"+valptr);
  for (i=0;i<count;i++)
    System.out.println(" "+i+"    "+statestk[i]+"      "+valstk[i]);
  System.out.println("======================");
}


//########## SEMANTIC VALUES ##########
//## **user defined:Value
String   yytext;//user variable to return contextual strings
Value yyval; //used to return semantic vals from action routines
Value yylval;//the 'lval' (result) I got from yylex()
Value valstk[] = new Value[YYSTACKSIZE];
int valptr;
//###############################################################
// methods: value stack push,pop,drop,peek.
//###############################################################
final void val_init()
{
  yyval=new Value();
  yylval=new Value();
  valptr=-1;
}
final void val_push(Value val)
{
  try {
    valptr++;
    valstk[valptr]=val;
  }
  catch (ArrayIndexOutOfBoundsException e) {
    int oldsize = valstk.length;
    int newsize = oldsize*2;
    Value[] newstack = new Value[newsize];
    System.arraycopy(valstk,0,newstack,0,oldsize);
    valstk = newstack;
    valstk[valptr]=val;
  }
}
final Value val_pop()
{
  return valstk[valptr--];
}
final void val_drop(int cnt)
{
  valptr -= cnt;
}
final Value val_peek(int relative)
{
  return valstk[valptr-relative];
}
//#### end semantic value section ####
public final static short SEMI=257;
public final static short DOT=258;
public final static short DOTDOTDOT=259;
public final static short COMMA=260;
public final static short STAR=261;
public final static short PERCENT=262;
public final static short EQUALS=263;
public final static short ANNOSTRING=264;
public final static short ANNOCHAR=265;
public final static short SLASH=266;
public final static short PLUS=267;
public final static short MINUS=268;
public final static short PACKAGE=269;
public final static short IMPORT=270;
public final static short PUBLIC=271;
public final static short PROTECTED=272;
public final static short PRIVATE=273;
public final static short STATIC=274;
public final static short FINAL=275;
public final static short ABSTRACT=276;
public final static short NATIVE=277;
public final static short STRICTFP=278;
public final static short SYNCHRONIZED=279;
public final static short TRANSIENT=280;
public final static short VOLATILE=281;
public final static short CLASS=282;
public final static short INTERFACE=283;
public final static short ENUM=284;
public final static short ANNOINTERFACE=285;
public final static short THROWS=286;
public final static short EXTENDS=287;
public final static short IMPLEMENTS=288;
public final static short SUPER=289;
public final static short DEFAULT=290;
public final static short BRACEOPEN=291;
public final static short BRACECLOSE=292;
public final static short SQUAREOPEN=293;
public final static short SQUARECLOSE=294;
public final static short PARENOPEN=295;
public final static short PARENCLOSE=296;
public final static short LESSTHAN=297;
public final static short GREATERTHAN=298;
public final static short LESSEQUALS=299;
public final static short GREATEREQUALS=300;
public final static short LESSTHAN2=301;
public final static short GREATERTHAN2=302;
public final static short GREATERTHAN3=303;
public final static short EXCLAMATION=304;
public final static short AMPERSAND2=305;
public final static short VERTLINE2=306;
public final static short EQUALS2=307;
public final static short NOTEQUALS=308;
public final static short TILDE=309;
public final static short AMPERSAND=310;
public final static short VERTLINE=311;
public final static short CIRCUMFLEX=312;
public final static short VOID=313;
public final static short QUERY=314;
public final static short COLON=315;
public final static short AT=316;
public final static short JAVADOCSTART=317;
public final static short JAVADOCEND=318;
public final static short JAVADOCEOL=319;
public final static short CODEBLOCK=320;
public final static short PARENBLOCK=321;
public final static short BYTE=322;
public final static short SHORT=323;
public final static short INT=324;
public final static short LONG=325;
public final static short CHAR=326;
public final static short FLOAT=327;
public final static short DOUBLE=328;
public final static short BOOLEAN=329;
public final static short IDENTIFIER=330;
public final static short JAVADOCTAG=331;
public final static short JAVADOCTOKEN=332;
public final static short BOOLEAN_LITERAL=333;
public final static short INTEGER_LITERAL=334;
public final static short LONG_LITERAL=335;
public final static short FLOAT_LITERAL=336;
public final static short DOUBLE_LITERAL=337;
public final static short CHAR_LITERAL=338;
public final static short STRING_LITERAL=339;
public final static short YYERRCODE=256;
final static short yylhs[] = {                           -1,
    0,   35,    0,   34,   34,   34,   34,   34,   34,   34,
   36,   37,   37,   38,   41,   43,   43,   44,   44,   42,
   42,   46,   45,   23,   23,   23,   31,   28,   28,   24,
   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
   47,   47,   47,   47,   49,    6,   48,   48,   48,   48,
   50,   50,   51,   52,    7,   53,   53,   54,   54,    3,
    3,    3,    4,    8,    8,    9,    9,   10,   10,   11,
   11,   12,   12,   13,   13,   14,   14,   14,   15,   15,
   15,   15,   15,   16,   16,   16,   16,   17,   17,   17,
   18,   18,   18,   18,   19,   19,   19,   20,   20,   20,
   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
   21,   22,   22,    1,    1,    5,    5,    5,    5,    5,
    5,    5,    2,    2,    2,    2,    2,    2,    2,    2,
   30,   56,   57,   32,   32,   25,   25,   26,   26,   55,
   55,   33,   33,   33,   33,   58,   58,   61,   59,   60,
   60,   62,   64,   62,   63,   63,   40,   65,   66,   66,
   68,   68,   68,   70,   70,   72,   72,   72,   72,   39,
   73,   74,   74,   74,   75,   75,   76,   76,   67,   67,
   77,   77,   69,   79,   69,   78,   78,   78,   78,   78,
   78,   78,   78,   27,   27,   83,   85,   80,   84,   86,
   84,   81,   81,   82,   87,   88,   88,   90,   90,   89,
   89,   91,   91,   92,   29,   29,   71,   71,   93,   93,
};
final static short yylen[] = {                            2,
    0,    0,    3,    1,    1,    1,    1,    1,    1,    1,
    3,    3,    4,    4,    1,    0,    2,    1,    1,    0,
    2,    0,    3,    1,    3,    3,    2,    0,    3,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    2,    2,    2,    0,    0,    4,    0,    3,    3,    2,
    1,    3,    3,    0,    4,    0,    1,    1,    3,    1,
    1,    1,    1,    1,    5,    1,    3,    1,    3,    1,
    3,    1,    3,    1,    3,    1,    3,    3,    1,    3,
    3,    3,    3,    1,    3,    3,    3,    1,    3,    3,
    1,    3,    3,    3,    2,    2,    1,    2,    2,    1,
    4,    5,    5,    4,    3,    1,    4,    3,    3,    4,
    1,    2,    3,    1,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    2,    0,    0,    6,    1,    1,    3,    1,    3,    1,
    3,    1,    1,    3,    3,    0,    1,    0,    4,    1,
    3,    1,    0,    4,    1,    3,    4,    4,    1,    3,
    0,    1,    3,    3,    2,    1,    2,    2,    3,    4,
    6,    1,    1,    1,    0,    2,    1,    3,    0,    2,
    1,    3,    0,    0,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    0,    6,    0,    0,
    4,    8,    7,    5,    3,    0,    2,    1,    3,    0,
    1,    1,    3,    5,    0,    1,    0,    2,    0,    2,
};
final static short yydefred[] = {                         1,
    2,    0,   10,    0,    0,    0,   16,    4,    3,    5,
    6,    7,    8,    9,    0,    0,    0,   24,    0,    0,
    0,  114,    0,   20,    0,   30,   31,   32,   33,   34,
   35,   36,   40,   37,   39,   38,  172,  173,    0,  174,
   42,   41,   43,    0,    0,  183,   11,    0,    0,   12,
    0,    0,    0,   19,   18,   17,    0,    0,  217,    0,
    0,    0,    0,    0,   26,   25,   13,  115,    0,   46,
   14,   22,   21,    0,  158,  148,    0,  147,    0,  157,
  183,    0,    0,  218,  165,  170,    0,    0,    0,    0,
   50,    0,    0,  124,  125,  126,  127,  128,  129,  130,
  123,    0,  120,  119,  118,  117,  116,  121,  122,    0,
    0,    0,   60,  106,   61,   62,   63,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   91,   97,  100,
    0,   51,    0,   16,  138,    0,    0,    0,    0,    0,
    0,    0,  164,    0,  163,  167,    0,  193,  186,  191,
  192,    0,  185,  187,  188,  189,  190,   95,   96,    0,
    0,    0,   99,   98,    0,    0,    0,    0,    0,    0,
   48,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   49,    0,    0,  132,    0,    0,    0,    0,
    0,  150,    0,    0,  171,  169,  196,    0,    0,    0,
    0,    0,    0,    0,    0,  105,   53,  109,  112,    0,
    0,  108,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   92,   94,   93,    0,   52,   58,    0,    0,    0,  139,
  137,    0,  153,    0,  149,    0,    0,    0,    0,  197,
    0,    0,  104,    0,  101,    0,  110,  113,  107,    0,
   55,    0,    0,  142,  140,    0,    0,  151,    0,    0,
    0,    0,  212,    0,    0,    0,   28,  199,    0,    0,
  103,  102,   65,   59,    0,    0,    0,    0,  155,    0,
    0,  205,  217,    0,    0,  194,  195,  204,    0,    0,
   29,   28,  144,  145,  141,  134,    0,  220,    0,  213,
    0,    0,  200,  198,    0,  156,  216,    0,    0,  203,
    0,    0,   28,  214,  201,  202,
};
final static short yydgoto[] = {                          1,
  110,  111,  112,  113,  114,  115,  116,  117,  118,  119,
  120,  121,  122,  123,  124,  125,  126,  127,  128,  129,
  130,  168,   19,   42,  136,  137,  308,  286,  328,  274,
  260,  210,  275,    9,    2,   10,   11,   43,   13,   14,
   24,   53,   25,   56,   73,  134,   15,   70,   52,  131,
  132,  133,  247,  248,  276,  249,  298,   77,   78,  201,
  140,  202,  300,  277,   16,   60,   75,   61,   64,   62,
   63,   85,   17,   44,  142,  204,  139,  153,   87,  154,
  155,  156,  157,  310,  288,  331,  258,  285,  281,  305,
  282,  283,  301,
};
final static short yysindex[] = {                         0,
    0,  -98,    0, -305, -252, -253,    0,    0,    0,    0,
    0,    0,    0,    0,  811, -166,  -49,    0, -108, -305,
   37,    0,  -11,    0, -309,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -70,    0,
    0,    0,    0,  -63,  -48,    0,    0, -229,  118,    0,
  -38,  -42,   14,    0,    0,    0,   28,   47,    0,   38,
  102,  112, -299,   69,    0,    0,    0,    0,   61,    0,
    0,    0,    0,   63,    0,    0,  115,    0, -299,    0,
    0,  -48,   48,    0,    0,    0, -251,  151,  151,  151,
    0,  151,  151,    0,    0,    0,    0,    0,    0,    0,
    0,  164,    0,    0,    0,    0,    0,    0,    0, -239,
  -77,  160,    0,    0,    0,    0,    0, -209,  142,  146,
  147,  148,  101,   82,  103,  153,   58,    0,    0,    0,
 -105,    0,  174,    0,    0,  172,  214,  224,  223,  203,
   63,   28,    0,    0,    0,    0,  215,    0,    0,    0,
    0,  220,    0,    0,    0,    0,    0,    0,    0, -128,
 -118,  238,    0,    0,  106, -184,  244,  -31,  257,  -30,
    0,  151,  151,  151,  151,  151,  151,  151,  151,  151,
  151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
  151,  211,    0,  106, -309,    0,  212,  218,   63,  258,
 -177,    0,  224,  289,    0,    0,    0,  260,  226,  224,
   63,  827, -106,  151,  -76,    0,    0,    0,    0,  272,
  263,    0,  276,  142,  245,  146,  147,  148,  101,   82,
   82,  103,  103,  103,  103,  153,  153,  153,   58,   58,
    0,    0,    0,  164,    0,    0,  267,  301,  -64,    0,
    0,  224,    0,  203,    0,   63,    0,  278,  260,    0,
  269,  236,    0,  827,    0,  151,    0,    0,    0,  151,
    0,  106,  -92,    0,    0,  311,   63,    0,  224,  256,
  277,  319,    0, -305, -205,  269,    0,    0,  286,  260,
    0,    0,    0,    0,   63,   63,  -64,  291,    0,  288,
  -41,    0,    0,  345,  352,    0,    0,    0,  -45, -207,
    0,    0,    0,    0,    0,    0,   63,    0,  358,    0,
 -305, -205,    0,    0,  -45,    0,    0,  294,  345,    0,
  294, -205,    0,    0,    0,    0,
};
final static short yyrindex[] = {                         0,
    0,  896,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    1,    0,   31,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -241,    0,    0,    0,    0,    0,
    0,   30,    0,    0,    0,    0,  336,   76,    0,    0,
  333,  -28,    0,  -71,    0,    0,    0,    0,  347,    0,
    0,    0,    0,    0,    0,    0, -115,    0,    0,    0,
    0, -241,  -36,    0,    0,    0,  247,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  285,    0,    0,    0,    0,    0,    0,    0,  308,
    0,    0,    0,    0,    0,    0,    0, -100,  111, -126,
  742,  713,  684,  156,  520,  414,  334,    0,    0,    0,
    0,    0,    0,    0,    0, -231, -156, -227,  359,    0,
    0,  336,    0, -236,    0,    0,  -35,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  809,
    0,    0,    0,    0,  347,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  132,   35,    0,    0,    0,    0, -141,
    0,    0, -124,   60,    0,    0,    0, -238,    0, -187,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  766,    0,  686,  754,  725,  701,  643,
  660,  546,  573,  599,  626,  440,  467,  493,  361,  387,
    0,    0,    0,    0,    0,    0,    0,  351,    0,    0,
    0, -140,    0,    0,    0,    0,   62, -192, -175,    0,
 -172,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  347, -136,    0,    0,  353,    0,    0,  -37,  235,
    0,  356,    0,    0,    0, -189,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -99,
    0,    0,    0, -164, -181,    0,    0,    0, -192,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  326,    0,
    0,    0,    0,    0, -192,    0,    0,    0, -143,    0,
    0,    0,    0,    0,    0,    0,
};
final static short yygindex[] = {                         0,
   12,  575, -160,  -87,    0,   11,    0,    0,    0,  498,
  503,  505,  502,  504,  259,  231,  265,  266,  -81, -142,
    0,   33,    4,  381,    0,    0,  -67, -196,    0, -148,
   24,  -72,  394,    0,    0,    0,    0,   13,  609,  616,
    0,    0,  570,    0,    0,    0,  618,    0,    0,    0,
  515,    0,    0,    0,    0,    0,    0,    0,  556,    0,
    0,  455,    0,    0,    0,    0,  576,  641,  649,    0,
  -59,  652,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   64,  -57,    0,    0,
    0,  430,    0,
};
final static int YYTABLESIZE=1181;
static short yytable[];
static { yytable();}
static void yytable(){
yytable = new short[]{                         79,
   45,  138,  162,  209,  217,  148,  158,  159,   21,   54,
  163,  164,    8,  261,   12,  161,    6,   23,  166,  138,
  184,   20,   55,   49,   18,   41,  135,  135,  135,   47,
   83,   65,  181,  246,  184,  184,  184,  184,  184,  184,
  184,  184,  184,  184,  184,  184,  184,  184,  184,  306,
  161,  306,  323,  167,  138,  160,  135,   59,  138,  135,
  184,  135,  262,  181,  206,    7,  135,   27,  203,  263,
   27,   28,   28,   84,  217,  207,   22,   18,  135,  184,
  184,   28,  254,  184,   28,  225,  131,  131,  217,   84,
  309,  138,  208,  184,   59,  208,  172,  218,  135,  149,
   66,  160,  136,  136,  173,   28,   27,  241,  242,  243,
   28,  294,  307,  209,  307,  325,  209,   28,  152,  182,
  255,  291,   28,  143,   45,  131,  252,  206,  299,  166,
   27,  136,  265,   68,  136,  177,  136,  131,  207,  169,
  136,  136,   28,  170,   28,   68,  313,  314,   47,   48,
  182,  220,  319,  136,  192,  208,  152,  131,    3,   64,
  154,  143,   41,  177,  167,   68,  177,  212,  326,   68,
    4,    5,  175,  136,  167,  175,  209,  214,   68,   68,
  169,  223,  293,  279,  292,  184,  221,   68,   68,  264,
  193,   64,  213,  215,  295,   64,  296,  280,  154,  184,
  184,  184,  184,  184,  184,  184,  184,  184,  184,  184,
  184,  184,  184,  184,   64,  167,  221,    6,    7,  266,
  166,  168,  178,  166,  168,  184,  220,  223,  162,   26,
   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
  284,   46,  324,  280,  184,  184,   51,  289,  184,  273,
  178,  322,   69,  178,  330,  166,  168,   45,  184,   57,
   45,  221,  221,  162,  336,  135,   58,  332,    7,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
   45,   45,   45,   45,   45,   45,   47,  304,  135,   47,
   84,   68,   45,   50,   48,   45,   45,   45,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
   47,   47,   47,   47,   47,   74,   45,   45,  189,  190,
   45,   47,  287,  191,  329,   47,   47,   88,   89,   80,
   45,   71,  217,  217,  217,  217,  217,  217,  217,  217,
  217,  217,  217,   76,   72,   47,   47,  176,   15,   47,
  176,  334,   23,  312,  335,   90,   91,  210,   81,   47,
   86,   15,  146,  146,   92,   23,  146,  146,  147,   93,
   66,   82,   88,   89,   67,   48,    6,  217,  180,  181,
  182,  183,   94,   95,   96,   97,   98,   99,  100,  101,
  102,  217,  135,  103,  104,  105,  106,  107,  108,  109,
   90,  141,   66,  184,  185,  186,   66,  178,  179,   92,
  232,  233,  234,  235,   93,   76,   66,   88,   89,  187,
  188,    6,   54,   56,   66,   66,  165,   94,   95,   96,
   97,   98,   99,  100,  101,   22,  230,  231,  103,  104,
  105,  106,  107,  108,  109,   90,  174,   76,  236,  237,
  238,   76,  239,  240,   92,  171,  175,  177,  176,   93,
   76,   76,   76,   76,  194,   76,   76,   76,  196,   76,
   76,  197,   94,   95,   96,   97,   98,   99,  100,  101,
   22,  198,  199,  103,  104,  105,  106,  107,  108,  109,
   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
   36,   37,   38,   39,   40,  219,  219,  219,  219,  219,
  219,  219,  219,  219,  219,  219,   76,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,  200,  216,  206,    6,    7,  219,  222,  207,
  244,  250,  114,   44,  253,  114,  114,  251,  256,  208,
  114,  114,  114,  267,  257,  259,  268,  269,  271,  270,
  272,  289,   44,  284,  219,  290,   44,  111,  111,  111,
  297,    6,  302,  111,  111,  111,   44,  114,  303,  311,
  114,  114,  114,  114,  114,  114,  114,  114,  316,  114,
  114,  114,  114,   88,  114,  114,  114,  317,  114,  111,
   88,   88,   48,  111,  111,  111,  111,  111,  111,  111,
  111,  321,  111,  111,  111,  111,  327,  111,  111,  111,
   89,  111,  111,  333,  159,   88,  179,   89,   89,   88,
   88,   88,   88,   88,   88,   88,   88,   54,   88,   88,
   88,   88,   57,   88,   88,   88,   90,   88,   88,  180,
  133,  211,   89,   90,   90,  215,   89,   89,   89,   89,
   89,   89,   89,   89,  161,   89,   89,   89,   89,  224,
   89,   89,   89,   84,   89,   89,  226,  228,   90,  227,
  229,  318,   90,   90,   90,   90,   90,   90,   90,   90,
  315,   90,   90,   90,   90,  150,   90,   90,   90,   85,
   90,   90,  151,  195,  152,   84,  245,  211,  278,   84,
   84,   84,   84,   84,   84,   84,   84,  205,   84,   84,
   84,   84,  145,   84,   84,   84,   87,   84,   84,  144,
  143,   85,  320,    0,    0,   85,   85,   85,   85,   85,
   85,   85,   85,    0,   85,   85,   85,   85,    0,   85,
   85,   85,   86,   85,   85,    0,    0,    0,   87,    0,
    0,    0,   87,   87,   87,   87,   87,   87,   87,   87,
    0,   87,   87,   87,   87,    0,   87,   87,   87,   79,
   87,   87,    0,    0,   86,    0,    0,    0,   86,   86,
   86,   86,   86,   86,   86,   86,    0,   86,   86,   86,
   86,    0,   86,   86,   86,   82,   86,   86,    0,    0,
    0,   79,    0,    0,    0,   79,   79,   79,   79,   79,
    0,    0,    0,    0,   79,   79,   79,   79,    0,   79,
   79,   79,   83,   79,   79,    0,    0,   82,    0,    0,
    0,   82,   82,   82,   82,   82,    0,    0,    0,    0,
   82,   82,   82,   82,    0,   82,   82,   82,   80,   82,
   82,    0,    0,    0,   83,    0,    0,    0,   83,   83,
   83,   83,   83,    0,    0,    0,    0,   83,   83,   83,
   83,    0,   83,   83,   83,   81,   83,   83,    0,    0,
   80,    0,    0,    0,   80,   80,   80,   80,   80,    0,
    0,    0,   77,   80,   80,   80,   80,    0,   80,   80,
   80,    0,   80,   80,    0,    0,    0,   81,    0,   78,
    0,   81,   81,   81,   81,   81,    0,    0,    0,    0,
   81,   81,   81,   81,   77,   81,   81,   81,   77,   81,
   81,    0,    0,   74,    0,   69,    0,   77,   77,   77,
   77,   78,   77,   77,   77,   78,   77,   77,    0,    0,
   75,    0,    0,    0,   78,   78,   78,   78,    0,   78,
   78,   78,   72,   78,   78,   74,    0,   69,    0,   74,
    0,   69,    0,    0,   73,    0,    0,    0,   74,   74,
   69,   69,   75,   74,   74,   74,   75,   74,   74,   69,
   69,   70,    0,    0,   72,   75,   75,    0,   72,    0,
   75,   75,   75,   71,   75,   75,   73,   72,   72,    0,
   73,    0,    0,   72,   72,   67,   72,   72,    0,   73,
   73,    0,    0,   70,    0,   73,   73,   70,   73,   73,
    0,    0,    0,    0,    0,   71,   70,   70,    0,   71,
    0,    0,   70,    0,    0,   70,   70,   67,   71,   71,
    0,   67,    0,    0,   71,    0,    0,   71,   71,  111,
  111,   67,    0,    0,  111,  111,  111,    0,    0,   67,
   67,   26,   27,   28,   29,   30,   31,   32,   33,   34,
   35,   36,   37,   38,   39,   40,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  111,  111,  111,  111,  111,
  111,  111,    0,  111,  111,  111,  111,    0,  111,  111,
  111,   90,  111,    0,    0,    0,    6,    7,    0,    0,
   92,    0,    0,    0,    0,   93,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   94,   95,
   96,   97,   98,   99,  100,  101,   22,    0,    0,  103,
  104,  105,  106,  107,  108,  109,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,
};
}
static short yycheck[];
static { yycheck(); }
static void yycheck() {
yycheck = new short[] {                         59,
    0,   74,   90,  152,  165,  257,   88,   89,    5,  319,
   92,   93,    2,  210,    2,  257,  316,    6,  258,  258,
  257,  274,  332,   20,  330,   15,  258,  259,  260,    0,
  330,  261,  260,  194,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  284,  285,  257,
  292,  257,  260,  293,  293,  292,  288,   45,  297,  291,
  297,  293,  211,  291,  257,  317,  298,  257,  141,  212,
  260,  259,  260,   63,  316,  257,  330,  330,  310,  316,
  317,  257,  260,  320,  260,  173,  259,  260,  330,   79,
  287,  330,  257,  330,   82,  260,  306,  282,  330,   87,
  330,   90,  259,  260,  314,  293,  296,  189,  190,  191,
  298,  272,  320,  257,  320,  312,  260,  293,  260,  260,
  298,  264,  310,  260,  291,  298,  199,  320,  277,  258,
  320,  288,  214,  260,  291,  260,  293,  310,  320,  258,
  297,  298,  330,  111,  320,  330,  295,  296,  257,  258,
  291,  258,  301,  310,  260,  320,  298,  330,  257,  260,
  260,  298,  152,  288,  293,  292,  291,  296,  317,  296,
  269,  270,  288,  330,  293,  291,  320,  296,  305,  306,
  258,  258,  270,  256,  266,  257,  293,  314,  315,  296,
  296,  292,  160,  161,  287,  296,  289,  257,  298,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  315,  293,  293,  316,  317,  296,
  257,  257,  260,  260,  260,  297,  258,  258,  257,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  286,  291,  310,  303,  316,  317,  258,  293,  320,  314,
  288,  309,  295,  291,  322,  292,  292,  257,  330,  330,
  260,  293,  293,  292,  332,  330,  330,  325,  317,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  257,  284,  330,  260,
  280,  330,  292,  257,  258,  295,  296,  297,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  288,  316,  317,  261,  262,
  320,  292,  259,  266,  321,  296,  297,  267,  268,  292,
  330,  318,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  297,  331,  316,  317,  288,  318,  320,
  291,  328,  318,  290,  331,  295,  296,  296,  257,  330,
  292,  331,  287,  288,  304,  331,  291,  320,  321,  309,
  260,  260,  267,  268,  257,  258,  316,  316,  297,  298,
  299,  300,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  330,  330,  333,  334,  335,  336,  337,  338,  339,
  295,  287,  292,  301,  302,  303,  296,  307,  308,  304,
  180,  181,  182,  183,  309,  260,  306,  267,  268,  267,
  268,  316,  291,  292,  314,  315,  263,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  178,  179,  333,  334,
  335,  336,  337,  338,  339,  295,  305,  292,  184,  185,
  186,  296,  187,  188,  304,  296,  311,  310,  312,  309,
  305,  306,  307,  308,  291,  310,  311,  312,  297,  314,
  315,  258,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  258,  260,  333,  334,  335,  336,  337,  338,  339,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  297,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  330,  296,  320,  316,  317,  294,  282,  320,
  330,  330,  258,  297,  287,  261,  262,  330,  260,  330,
  266,  267,  268,  282,  295,  330,  294,  282,  292,  315,
  260,  293,  316,  286,  330,  330,  320,  260,  261,  262,
  260,  316,  296,  266,  267,  268,  330,  293,  260,  294,
  296,  297,  298,  299,  300,  301,  302,  303,  298,  305,
  306,  307,  308,  260,  310,  311,  312,  310,  314,  292,
  267,  268,  258,  296,  297,  298,  299,  300,  301,  302,
  303,  260,  305,  306,  307,  308,  259,  310,  311,  312,
  260,  314,  315,  330,  292,  292,  291,  267,  268,  296,
  297,  298,  299,  300,  301,  302,  303,  291,  305,  306,
  307,  308,  292,  310,  311,  312,  260,  314,  315,  291,
  298,  296,  292,  267,  268,  330,  296,  297,  298,  299,
  300,  301,  302,  303,   90,  305,  306,  307,  308,  172,
  310,  311,  312,  260,  314,  315,  174,  176,  292,  175,
  177,  301,  296,  297,  298,  299,  300,  301,  302,  303,
  297,  305,  306,  307,  308,   87,  310,  311,  312,  260,
  314,  315,   87,  134,   87,  292,  192,  152,  254,  296,
  297,  298,  299,  300,  301,  302,  303,  142,  305,  306,
  307,  308,   82,  310,  311,  312,  260,  314,  315,   81,
   79,  292,  303,   -1,   -1,  296,  297,  298,  299,  300,
  301,  302,  303,   -1,  305,  306,  307,  308,   -1,  310,
  311,  312,  260,  314,  315,   -1,   -1,   -1,  292,   -1,
   -1,   -1,  296,  297,  298,  299,  300,  301,  302,  303,
   -1,  305,  306,  307,  308,   -1,  310,  311,  312,  260,
  314,  315,   -1,   -1,  292,   -1,   -1,   -1,  296,  297,
  298,  299,  300,  301,  302,  303,   -1,  305,  306,  307,
  308,   -1,  310,  311,  312,  260,  314,  315,   -1,   -1,
   -1,  292,   -1,   -1,   -1,  296,  297,  298,  299,  300,
   -1,   -1,   -1,   -1,  305,  306,  307,  308,   -1,  310,
  311,  312,  260,  314,  315,   -1,   -1,  292,   -1,   -1,
   -1,  296,  297,  298,  299,  300,   -1,   -1,   -1,   -1,
  305,  306,  307,  308,   -1,  310,  311,  312,  260,  314,
  315,   -1,   -1,   -1,  292,   -1,   -1,   -1,  296,  297,
  298,  299,  300,   -1,   -1,   -1,   -1,  305,  306,  307,
  308,   -1,  310,  311,  312,  260,  314,  315,   -1,   -1,
  292,   -1,   -1,   -1,  296,  297,  298,  299,  300,   -1,
   -1,   -1,  260,  305,  306,  307,  308,   -1,  310,  311,
  312,   -1,  314,  315,   -1,   -1,   -1,  292,   -1,  260,
   -1,  296,  297,  298,  299,  300,   -1,   -1,   -1,   -1,
  305,  306,  307,  308,  292,  310,  311,  312,  296,  314,
  315,   -1,   -1,  260,   -1,  260,   -1,  305,  306,  307,
  308,  292,  310,  311,  312,  296,  314,  315,   -1,   -1,
  260,   -1,   -1,   -1,  305,  306,  307,  308,   -1,  310,
  311,  312,  260,  314,  315,  292,   -1,  292,   -1,  296,
   -1,  296,   -1,   -1,  260,   -1,   -1,   -1,  305,  306,
  305,  306,  292,  310,  311,  312,  296,  314,  315,  314,
  315,  260,   -1,   -1,  292,  305,  306,   -1,  296,   -1,
  310,  311,  312,  260,  314,  315,  292,  305,  306,   -1,
  296,   -1,   -1,  311,  312,  260,  314,  315,   -1,  305,
  306,   -1,   -1,  292,   -1,  311,  312,  296,  314,  315,
   -1,   -1,   -1,   -1,   -1,  292,  305,  306,   -1,  296,
   -1,   -1,  311,   -1,   -1,  314,  315,  292,  305,  306,
   -1,  296,   -1,   -1,  311,   -1,   -1,  314,  315,  261,
  262,  306,   -1,   -1,  266,  267,  268,   -1,   -1,  314,
  315,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  297,  298,  299,  300,  301,
  302,  303,   -1,  305,  306,  307,  308,   -1,  310,  311,
  312,  295,  314,   -1,   -1,   -1,  316,  317,   -1,   -1,
  304,   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  322,  323,
  324,  325,  326,  327,  328,  329,  330,   -1,   -1,  333,
  334,  335,  336,  337,  338,  339,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,
};
}
final static short YYFINAL=1;
final static short YYMAXTOKEN=339;
final static String yyname[] = {
"end-of-file",null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,"SEMI","DOT","DOTDOTDOT","COMMA","STAR","PERCENT","EQUALS",
"ANNOSTRING","ANNOCHAR","SLASH","PLUS","MINUS","PACKAGE","IMPORT","PUBLIC",
"PROTECTED","PRIVATE","STATIC","FINAL","ABSTRACT","NATIVE","STRICTFP",
"SYNCHRONIZED","TRANSIENT","VOLATILE","CLASS","INTERFACE","ENUM",
"ANNOINTERFACE","THROWS","EXTENDS","IMPLEMENTS","SUPER","DEFAULT","BRACEOPEN",
"BRACECLOSE","SQUAREOPEN","SQUARECLOSE","PARENOPEN","PARENCLOSE","LESSTHAN",
"GREATERTHAN","LESSEQUALS","GREATEREQUALS","LESSTHAN2","GREATERTHAN2",
"GREATERTHAN3","EXCLAMATION","AMPERSAND2","VERTLINE2","EQUALS2","NOTEQUALS",
"TILDE","AMPERSAND","VERTLINE","CIRCUMFLEX","VOID","QUERY","COLON","AT",
"JAVADOCSTART","JAVADOCEND","JAVADOCEOL","CODEBLOCK","PARENBLOCK","BYTE",
"SHORT","INT","LONG","CHAR","FLOAT","DOUBLE","BOOLEAN","IDENTIFIER",
"JAVADOCTAG","JAVADOCTOKEN","BOOLEAN_LITERAL","INTEGER_LITERAL","LONG_LITERAL",
"FLOAT_LITERAL","DOUBLE_LITERAL","CHAR_LITERAL","STRING_LITERAL",
};
final static String yyrule[] = {
"$accept : file",
"file :",
"$$1 :",
"file : file $$1 filepart",
"filepart : annotation",
"filepart : package",
"filepart : import",
"filepart : javadoc",
"filepart : class",
"filepart : enum",
"filepart : SEMI",
"package : PACKAGE fullidentifier SEMI",
"import : IMPORT fullidentifier SEMI",
"import : IMPORT STATIC fullidentifier SEMI",
"javadoc : JAVADOCSTART javadocdescription javadoctags JAVADOCEND",
"javadocdescription : javadoctokens",
"javadoctokens :",
"javadoctokens : javadoctokens javadoctoken",
"javadoctoken : JAVADOCTOKEN",
"javadoctoken : JAVADOCEOL",
"javadoctags :",
"javadoctags : javadoctags javadoctag",
"$$2 :",
"javadoctag : JAVADOCTAG $$2 javadoctokens",
"fullidentifier : IDENTIFIER",
"fullidentifier : fullidentifier DOT IDENTIFIER",
"fullidentifier : fullidentifier DOT STAR",
"arrayidentifier : IDENTIFIER dimensions",
"dimensions :",
"dimensions : dimensions SQUAREOPEN SQUARECLOSE",
"modifier : PUBLIC",
"modifier : PROTECTED",
"modifier : PRIVATE",
"modifier : STATIC",
"modifier : FINAL",
"modifier : ABSTRACT",
"modifier : NATIVE",
"modifier : SYNCHRONIZED",
"modifier : VOLATILE",
"modifier : TRANSIENT",
"modifier : STRICTFP",
"modifiers : modifiers modifier",
"modifiers : modifiers annotation",
"modifiers : modifiers javadoc",
"modifiers :",
"$$3 :",
"annotation : AT name $$3 annotationParensOpt",
"annotationParensOpt :",
"annotationParensOpt : PARENOPEN value PARENCLOSE",
"annotationParensOpt : PARENOPEN valuePairs PARENCLOSE",
"annotationParensOpt : PARENOPEN PARENCLOSE",
"valuePairs : valuePair",
"valuePairs : valuePairs COMMA valuePair",
"valuePair : IDENTIFIER EQUALS value",
"$$4 :",
"arrayInitializer : $$4 BRACEOPEN valuesOpt BRACECLOSE",
"valuesOpt :",
"valuesOpt : values",
"values : value",
"values : values COMMA value",
"value : expression",
"value : annotation",
"value : arrayInitializer",
"expression : conditionalExpression",
"conditionalExpression : conditionalOrExpression",
"conditionalExpression : conditionalOrExpression QUERY expression COLON expression",
"conditionalOrExpression : conditionalAndExpression",
"conditionalOrExpression : conditionalOrExpression VERTLINE2 conditionalAndExpression",
"conditionalAndExpression : inclusiveOrExpression",
"conditionalAndExpression : conditionalAndExpression AMPERSAND2 inclusiveOrExpression",
"inclusiveOrExpression : exclusiveOrExpression",
"inclusiveOrExpression : inclusiveOrExpression VERTLINE exclusiveOrExpression",
"exclusiveOrExpression : andExpression",
"exclusiveOrExpression : exclusiveOrExpression CIRCUMFLEX andExpression",
"andExpression : equalityExpression",
"andExpression : andExpression AMPERSAND equalityExpression",
"equalityExpression : relationalExpression",
"equalityExpression : equalityExpression EQUALS2 relationalExpression",
"equalityExpression : equalityExpression NOTEQUALS relationalExpression",
"relationalExpression : shiftExpression",
"relationalExpression : relationalExpression LESSEQUALS shiftExpression",
"relationalExpression : relationalExpression GREATEREQUALS shiftExpression",
"relationalExpression : relationalExpression LESSTHAN shiftExpression",
"relationalExpression : relationalExpression GREATERTHAN shiftExpression",
"shiftExpression : additiveExpression",
"shiftExpression : shiftExpression LESSTHAN2 additiveExpression",
"shiftExpression : shiftExpression GREATERTHAN3 additiveExpression",
"shiftExpression : shiftExpression GREATERTHAN2 additiveExpression",
"additiveExpression : multiplicativeExpression",
"additiveExpression : additiveExpression PLUS multiplicativeExpression",
"additiveExpression : additiveExpression MINUS multiplicativeExpression",
"multiplicativeExpression : unaryExpression",
"multiplicativeExpression : multiplicativeExpression STAR unaryExpression",
"multiplicativeExpression : multiplicativeExpression SLASH unaryExpression",
"multiplicativeExpression : multiplicativeExpression PERCENT unaryExpression",
"unaryExpression : PLUS unaryExpression",
"unaryExpression : MINUS unaryExpression",
"unaryExpression : unaryExpressionNotPlusMinus",
"unaryExpressionNotPlusMinus : TILDE unaryExpression",
"unaryExpressionNotPlusMinus : EXCLAMATION unaryExpression",
"unaryExpressionNotPlusMinus : primary",
"primary : PARENOPEN primitiveType PARENCLOSE unaryExpression",
"primary : PARENOPEN primitiveType dims PARENCLOSE unaryExpression",
"primary : PARENOPEN name dims PARENCLOSE unaryExpressionNotPlusMinus",
"primary : PARENOPEN name PARENCLOSE unaryExpressionNotPlusMinus",
"primary : PARENOPEN expression PARENCLOSE",
"primary : literal",
"primary : primitiveType dims DOT CLASS",
"primary : primitiveType DOT CLASS",
"primary : name DOT CLASS",
"primary : name dims DOT CLASS",
"primary : name",
"dims : SQUAREOPEN SQUARECLOSE",
"dims : dims SQUAREOPEN SQUARECLOSE",
"name : IDENTIFIER",
"name : name DOT IDENTIFIER",
"literal : DOUBLE_LITERAL",
"literal : FLOAT_LITERAL",
"literal : LONG_LITERAL",
"literal : INTEGER_LITERAL",
"literal : BOOLEAN_LITERAL",
"literal : CHAR_LITERAL",
"literal : STRING_LITERAL",
"primitiveType : BOOLEAN",
"primitiveType : BYTE",
"primitiveType : SHORT",
"primitiveType : INT",
"primitiveType : LONG",
"primitiveType : CHAR",
"primitiveType : FLOAT",
"primitiveType : DOUBLE",
"type : classtype dimensions",
"$$5 :",
"$$6 :",
"classtype : typedeclspecifier LESSTHAN $$5 typearglist $$6 GREATERTHAN",
"classtype : typedeclspecifier",
"typedeclspecifier : typename",
"typedeclspecifier : classtype DOT IDENTIFIER",
"typename : IDENTIFIER",
"typename : typename DOT IDENTIFIER",
"typearglist : typearg",
"typearglist : typearglist COMMA typearg",
"typearg : type",
"typearg : QUERY",
"typearg : QUERY EXTENDS type",
"typearg : QUERY SUPER type",
"opt_typeparams :",
"opt_typeparams : typeparams",
"$$7 :",
"typeparams : LESSTHAN $$7 typeparamlist GREATERTHAN",
"typeparamlist : typeparam",
"typeparamlist : typeparamlist COMMA typeparam",
"typeparam : IDENTIFIER",
"$$8 :",
"typeparam : IDENTIFIER EXTENDS $$8 typeboundlist",
"typeboundlist : type",
"typeboundlist : typeboundlist AMPERSAND type",
"enum : enum_definition BRACEOPEN enum_body BRACECLOSE",
"enum_definition : modifiers ENUM IDENTIFIER opt_implements",
"enum_body : enum_values",
"enum_body : enum_values SEMI members",
"enum_values :",
"enum_values : enum_value",
"enum_values : enum_value COMMA enum_values",
"enum_value : javadoc opt_annotations enum_constructor",
"enum_value : opt_annotations enum_constructor",
"enum_constructor : IDENTIFIER",
"enum_constructor : IDENTIFIER CODEBLOCK",
"enum_constructor : IDENTIFIER PARENBLOCK",
"enum_constructor : IDENTIFIER PARENBLOCK CODEBLOCK",
"class : classdefinition BRACEOPEN members BRACECLOSE",
"classdefinition : modifiers classorinterface IDENTIFIER opt_typeparams opt_extends opt_implements",
"classorinterface : CLASS",
"classorinterface : INTERFACE",
"classorinterface : ANNOINTERFACE",
"opt_extends :",
"opt_extends : EXTENDS extendslist",
"extendslist : classtype",
"extendslist : extendslist COMMA classtype",
"opt_implements :",
"opt_implements : IMPLEMENTS implementslist",
"implementslist : classtype",
"implementslist : implementslist COMMA classtype",
"members :",
"$$9 :",
"members : members $$9 member",
"member : javadoc",
"member : fields",
"member : method",
"member : constructor",
"member : static_block",
"member : class",
"member : enum",
"member : SEMI",
"memberend : SEMI",
"memberend : CODEBLOCK",
"static_block : modifiers CODEBLOCK",
"$$10 :",
"fields : modifiers type arrayidentifier $$10 extrafields memberend",
"extrafields :",
"$$11 :",
"extrafields : extrafields COMMA $$11 arrayidentifier",
"method : modifiers typeparams type IDENTIFIER methoddef dimensions opt_exceptions memberend",
"method : modifiers type IDENTIFIER methoddef dimensions opt_exceptions memberend",
"constructor : modifiers IDENTIFIER methoddef opt_exceptions memberend",
"methoddef : PARENOPEN opt_params PARENCLOSE",
"opt_exceptions :",
"opt_exceptions : THROWS exceptionlist",
"exceptionlist : fullidentifier",
"exceptionlist : exceptionlist COMMA fullidentifier",
"opt_params :",
"opt_params : paramlist",
"paramlist : param",
"paramlist : paramlist COMMA param",
"param : opt_annotations opt_parammodifiers type varargs arrayidentifier",
"varargs :",
"varargs : DOTDOTDOT",
"opt_annotations :",
"opt_annotations : opt_annotations annotation",
"opt_parammodifiers :",
"opt_parammodifiers : opt_parammodifiers modifier",
};

//#line 534 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"

private Lexer lexer;
private Builder builder;
private StringBuffer textBuffer = new StringBuffer();
private ClassDef cls = new ClassDef();
private MethodDef mth = new MethodDef();
private List annotationStack = new ArrayList(); // Use ArrayList intead of Stack because it is unsynchronized 
private Annotation annotation = null;
private List annoValueListStack = new ArrayList(); // Use ArrayList intead of Stack because it is unsynchronized
private List annoValueList = null;
private FieldDef param = new FieldDef();
private java.util.Set modifiers = new java.util.HashSet();
private TypeDef fieldType;
private TypeVariableDef typeVariable;
private Stack typeStack = new Stack();
private int line;
private int column;
private boolean debugLexer;

private void appendToBuffer(String word) {
    if (textBuffer.length() > 0) {
        char lastChar = textBuffer.charAt(textBuffer.length() - 1);
        if (!Character.isWhitespace(lastChar)) {
            textBuffer.append(' ');
        }
    }
    textBuffer.append(word);
}

private String buffer() {
    String result = textBuffer.toString().trim();
    textBuffer.setLength(0);
    return result;
}

public Parser(Lexer lexer, Builder builder) {
    this.lexer = lexer;
    this.builder = builder;
}

public void setDebugParser(boolean debug) {
    yydebug = debug;
}

public void setDebugLexer(boolean debug) {
    debugLexer = debug;
}

/**
 * Parse file. Return true if successful.
 */
public boolean parse() {
    return yyparse() == 0;
}

private int yylex() {
    try {
        final int result = lexer.lex();
        yylval = new Value();
        yylval.sval = lexer.text();
        if (debugLexer) {
            System.err.println("Token: " + yyname[result] + " \"" + yylval.sval + "\"");
        }
        return result;
    }
    catch(IOException e) {
        return 0;
    }
}

private void yyerror(String msg) {
    throw new ParseException(msg, lexer.getLine(), lexer.getColumn());
}

private class Value {
	Object oval;
    String sval;
    int ival;
	boolean bval;
    TypeDef type;
    AnnotationValue annoval;
}


private void makeField(TypeDef field, String body) {
    FieldDef fd = new FieldDef();
    fd.lineNumber = line;
    fd.modifiers.addAll(modifiers); 
    fd.name = field.name;
    fd.type = fieldType;
    fd.dimensions = field.dimensions;
    fd.body = body;
    builder.addField(fd);
}

private String convertString(String str) {
	StringBuffer buf = new StringBuffer();
	boolean escaped = false;
	int unicode = 0;
	int value = 0;
	int octal = 0;
	boolean consumed = false;
	
	for(int i = 0; i < str.length(); ++ i) {
		char ch = str.charAt( i );
		
		if(octal > 0) {
			if( value >= '0' && value <= '7' ) {
				value = ( value << 3 ) | Character.digit( ch, 8 );
				-- octal;
				consumed = true;
			}
			else {
				octal = 0;
			}
			
			if( octal == 0 ) {
				buf.append( (char) value );		
				value = 0;
			}
		}
		
		if(!consumed) {
			if(unicode > 0) {
				value = ( value << 4 ) | Character.digit( ch, 16 );
				
				-- unicode;
		
				if(unicode == 0) {
					buf.append( (char)value );
					value = 0;
				}
			}
			else if(ch == '\\') {
				escaped = true;
			}
			else if(escaped) {
				if(ch == 'u' || ch == 'U') {
					unicode = 4;
				}
				else if(ch >= '0' && ch <= '7') {
					octal = (ch > '3') ? 1 : 2;
					value = Character.digit( ch, 8 );
				}
				else {
					switch( ch ) {
						case 'b':
							buf.append('\b');
							break;
							
						case 'f':
							buf.append('\f');
							break;
							
						case 'n':
							buf.append('\n');
							break;
							
						case 'r':
							buf.append('\r');
							break;
							
						case 't':
							buf.append('\t');
							break;
							
						case '\'':
							buf.append('\'');
							break;
	
						case '\"':
							buf.append('\"');
							break;
	
						case '\\':
							buf.append('\\');
							break;
							
						default:
							yyerror( "Illegal escape character '" + ch + "'" );
					}
				}
				
				escaped = false;
			}
			else {
				buf.append( ch );
			}
		}
	}

	return buf.toString();
}

private Boolean toBoolean(String str) {
	str = str.trim();

	return new Boolean( str );
}

private Integer toInteger(String str) {
	str = str.trim();
	
	Integer result;
	
	if(str.startsWith("0x") || str.startsWith( "0X" ) ) {
		result = new Integer( Integer.parseInt( str.substring( 2 ), 16 ) );
	}
	else if(str.length() > 1 && str.startsWith("0") ) {
		result = new Integer( Integer.parseInt( str.substring( 1 ), 8 ) );
	}
	else {
		result = new Integer( str );
	}
	
	return result;
}

private Long toLong(String str) {
	str = str.trim();

	Long result;
	
	if( !str.endsWith("l") && !str.endsWith("L") ) {
		yyerror( "Long literal must end with 'l' or 'L'." );
	}
	
	int len = str.length() - 1;
	
	if(str.startsWith("0x") || str.startsWith( "0X" ) ) {
		result = new Long( Long.parseLong( str.substring( 2, len ), 16 ) );
	}
	else if(str.startsWith("0") ) {
		result = new Long( Long.parseLong( str.substring( 1, len ), 8 ) );
	}
	else {
		result = new Long( str.substring( 0, len ) );
	}

	return result;
}

private Float toFloat(String str) {
	str = str.trim();
	return new Float( str );
}

private Double toDouble(String str) {
	str = str.trim();

	if( !str.endsWith("d") && !str.endsWith("D") ) {
		yyerror( "Double literal must end with 'd' or 'D'." );
	}
	
	return new Double( str.substring( 0, str.length() - 1 ) );
}

/**
 * Convert a character literal into a character.
 */
private Character toChar(String str) {
	str = str.trim();

	if( !str.startsWith("'") && !str.endsWith("'") ) {
		yyerror("Character must be single quoted.");
	}

	String str2 = convertString( str.substring( 1, str.length() - 1 ) );
	
	if( str2.length() != 1) {
		yyerror("Only one character allowed in character constants.");
	}
	
	return new Character( str2.charAt( 0 ) );
}

/**
 * Convert a string literal into a string.
 */
private String toString(String str) {
	str = str.trim();

	if( str.length() < 2 && !str.startsWith("\"") && !str.endsWith("\"") ) {
		yyerror("String must be double quoted.");
	}

	String str2 = convertString( str.substring( 1, str.length() - 1 ) );
	return str2;
}
//#line 1158 "Parser.java"
//###############################################################
// method: yylexdebug : check lexer state
//###############################################################
void yylexdebug(int state,int ch)
{
String s=null;
  if (ch < 0) ch=0;
  if (ch <= YYMAXTOKEN) //check index bounds
     s = yyname[ch];    //now get it
  if (s==null)
    s = "illegal-symbol";
  debug("state "+state+", reading "+ch+" ("+s+")");
}





//The following are now global, to aid in error reporting
int yyn;       //next next thing to do
int yym;       //
int yystate;   //current parsing state from state table
String yys;    //current token string


//###############################################################
// method: yyparse : parse input and execute indicated items
//###############################################################
int yyparse()
{
boolean doaction;
  init_stacks();
  yynerrs = 0;
  yyerrflag = 0;
  yychar = -1;          //impossible char forces a read
  yystate=0;            //initial state
  state_push(yystate);  //save it
  while (true) //until parsing is done, either correctly, or w/error
    {
    doaction=true;
    if (yydebug) debug("loop"); 
    //#### NEXT ACTION (from reduction table)
    for (yyn=yydefred[yystate];yyn==0;yyn=yydefred[yystate])
      {
      if (yydebug) debug("yyn:"+yyn+"  state:"+yystate+"  yychar:"+yychar);
      if (yychar < 0)      //we want a char?
        {
        yychar = yylex();  //get next token
        if (yydebug) debug(" next yychar:"+yychar);
        //#### ERROR CHECK ####
        if (yychar < 0)    //it it didn't work/error
          {
          yychar = 0;      //change it to default string (no -1!)
          if (yydebug)
            yylexdebug(yystate,yychar);
          }
        }//yychar<0
      yyn = yysindex[yystate];  //get amount to shift by (shift index)
      if ((yyn != 0) && (yyn += yychar) >= 0 &&
          yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
        {
        if (yydebug)
          debug("state "+yystate+", shifting to state "+yytable[yyn]);
        //#### NEXT STATE ####
        yystate = yytable[yyn];//we are in a new state
        state_push(yystate);   //save it
        val_push(yylval);      //push our lval as the input for next rule
        yychar = -1;           //since we have 'eaten' a token, say we need another
        if (yyerrflag > 0)     //have we recovered an error?
           --yyerrflag;        //give ourselves credit
        doaction=false;        //but don't process yet
        break;   //quit the yyn=0 loop
        }

    yyn = yyrindex[yystate];  //reduce
    if ((yyn !=0 ) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
      {   //we reduced!
      if (yydebug) debug("reduce");
      yyn = yytable[yyn];
      doaction=true; //get ready to execute
      break;         //drop down to actions
      }
    else //ERROR RECOVERY
      {
      if (yyerrflag==0)
        {
        yyerror("syntax error");
        yynerrs++;
        }
      if (yyerrflag < 3) //low error count?
        {
        yyerrflag = 3;
        while (true)   //do until break
          {
          if (stateptr<0)   //check for under & overflow here
            {
            yyerror("stack underflow. aborting...");  //note lower case 's'
            return 1;
            }
          yyn = yysindex[state_peek(0)];
          if ((yyn != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
            if (yydebug)
              debug("state "+state_peek(0)+", error recovery shifting to state "+yytable[yyn]+" ");
            yystate = yytable[yyn];
            state_push(yystate);
            val_push(yylval);
            doaction=false;
            break;
            }
          else
            {
            if (yydebug)
              debug("error recovery discarding state "+state_peek(0)+" ");
            if (stateptr<0)   //check for under & overflow here
              {
              yyerror("Stack underflow. aborting...");  //capital 'S'
              return 1;
              }
            state_pop();
            val_pop();
            }
          }
        }
      else            //discard this token
        {
        if (yychar == 0)
          return 1; //yyabort
        if (yydebug)
          {
          yys = null;
          if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
          if (yys == null) yys = "illegal-symbol";
          debug("state "+yystate+", error recovery discards token "+yychar+" ("+yys+")");
          }
        yychar = -1;  //read another
        }
      }//end error recovery
    }//yyn=0 loop
    if (!doaction)   //any reason not to proceed?
      continue;      //skip action
    yym = yylen[yyn];          //get count of terminals on rhs
    if (yydebug)
      debug("state "+yystate+", reducing "+yym+" by rule "+yyn+" ("+yyrule[yyn]+")");
    if (yym>0)                 //if count of rhs not 'nil'
      yyval = val_peek(yym-1); //get current semantic value
    switch(yyn)
      {
//########## USER-SUPPLIED ACTIONS ##########
case 2:
//#line 56 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 4:
//#line 59 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ builder.addAnnotation((Annotation) val_peek(0).annoval); }
break;
case 11:
//#line 62 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ builder.addPackage(new PackageDef(val_peek(1).sval, line)); }
break;
case 12:
//#line 65 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ builder.addImport(val_peek(1).sval); }
break;
case 13:
//#line 66 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ builder.addImport(val_peek(1).sval); }
break;
case 15:
//#line 74 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ 
        builder.addJavaDoc(buffer()); 
    }
break;
case 18:
//#line 81 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        appendToBuffer(val_peek(0).sval);
    }
break;
case 19:
//#line 84 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        textBuffer.append('\n');
    }
break;
case 22:
//#line 91 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 23:
//#line 92 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        builder.addJavaDocTag(new TagDef(val_peek(2).sval.substring(1), buffer(), line)); 
    }
break;
case 24:
//#line 101 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 25:
//#line 102 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + '.' + val_peek(0).sval; }
break;
case 26:
//#line 103 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + ".*"; }
break;
case 27:
//#line 106 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        yyval.type = new TypeDef(val_peek(1).sval,val_peek(0).ival);
    }
break;
case 28:
//#line 111 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.ival = 0; }
break;
case 29:
//#line 112 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        yyval.ival = val_peek(2).ival + 1; 
    }
break;
case 30:
//#line 118 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "public"; }
break;
case 31:
//#line 119 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "protected"; }
break;
case 32:
//#line 120 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "private"; }
break;
case 33:
//#line 121 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "static"; }
break;
case 34:
//#line 122 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "final"; }
break;
case 35:
//#line 123 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "abstract"; }
break;
case 36:
//#line 124 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "native"; }
break;
case 37:
//#line 125 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "synchronized"; }
break;
case 38:
//#line 126 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "volatile"; }
break;
case 39:
//#line 127 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "transient"; }
break;
case 40:
//#line 128 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "strictfp"; }
break;
case 41:
//#line 131 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ modifiers.add(val_peek(0).sval); }
break;
case 42:
//#line 132 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ builder.addAnnotation((Annotation) val_peek(0).annoval); }
break;
case 45:
//#line 143 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ 
    	annotationStack.add(annotation);
    	annotation = new Annotation(builder.createType(val_peek(0).sval, 0), lexer.getLine()); 
    }
break;
case 46:
//#line 148 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    	yyval.annoval = annotation;
    	annotation = (Annotation)annotationStack.remove(annotationStack.size() - 1);
    }
break;
case 48:
//#line 155 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ annotation.setProperty("value", val_peek(1).annoval); }
break;
case 53:
//#line 164 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ annotation.setProperty(val_peek(2).sval, val_peek(0).annoval); }
break;
case 54:
//#line 167 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    	annoValueListStack.add(annoValueList);
    	annoValueList = new ArrayList(); 
    }
break;
case 55:
//#line 172 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    	yyval.annoval = new AnnotationValueList(annoValueList);
    	annoValueList = (List)annoValueListStack.remove(annoValueListStack.size() - 1);
    }
break;
case 58:
//#line 182 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ annoValueList.add(val_peek(0).annoval); }
break;
case 59:
//#line 183 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ annoValueList.add(val_peek(0).annoval); }
break;
case 60:
//#line 186 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 61:
//#line 187 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 62:
//#line 188 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 63:
//#line 191 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 64:
//#line 194 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 65:
//#line 195 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationQuery(val_peek(4).annoval, val_peek(2).annoval, val_peek(0).annoval); }
break;
case 66:
//#line 198 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 67:
//#line 199 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 68:
//#line 202 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 69:
//#line 203 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalAnd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 70:
//#line 206 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 71:
//#line 207 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 72:
//#line 210 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 73:
//#line 211 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationExclusiveOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 74:
//#line 214 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 75:
//#line 215 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationAnd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 76:
//#line 218 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 77:
//#line 219 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 78:
//#line 220 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationNotEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 79:
//#line 223 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 80:
//#line 224 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLessEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 81:
//#line 225 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationGreaterEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 82:
//#line 226 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLessThan(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 83:
//#line 227 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationGreaterThan(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 84:
//#line 230 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 85:
//#line 231 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationShiftLeft(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 86:
//#line 232 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationUnsignedShiftRight(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 87:
//#line 233 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationShiftRight(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 88:
//#line 236 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 89:
//#line 237 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationAdd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 90:
//#line 238 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationSubtract(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 91:
//#line 241 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 92:
//#line 242 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationMultiply(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 93:
//#line 243 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationDivide(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 94:
//#line 244 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationRemainder(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 95:
//#line 247 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationPlusSign(val_peek(0).annoval); }
break;
case 96:
//#line 248 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationMinusSign(val_peek(0).annoval); }
break;
case 97:
//#line 249 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 98:
//#line 252 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationNot(val_peek(0).annoval); }
break;
case 99:
//#line 253 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalNot(val_peek(0).annoval); }
break;
case 101:
//#line 257 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(2).sval, 0), val_peek(0).annoval); }
break;
case 102:
//#line 258 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(3).sval, val_peek(2).ival), val_peek(0).annoval); }
break;
case 103:
//#line 259 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(3).sval, val_peek(2).ival), val_peek(0).annoval); }
break;
case 104:
//#line 260 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(2).sval, 0), val_peek(0).annoval); }
break;
case 105:
//#line 261 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationParenExpression(val_peek(1).annoval); }
break;
case 106:
//#line 262 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 107:
//#line 263 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(3).sval, 0)); }
break;
case 108:
//#line 264 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(2).sval, 0)); }
break;
case 109:
//#line 265 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(2).sval, 0)); }
break;
case 110:
//#line 266 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(3).sval, 0)); }
break;
case 111:
//#line 267 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationFieldRef(val_peek(0).sval); }
break;
case 112:
//#line 270 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.ival = 1; }
break;
case 113:
//#line 271 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.ival = val_peek(2).ival + 1; }
break;
case 114:
//#line 274 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 115:
//#line 275 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + "." + val_peek(0).sval; }
break;
case 116:
//#line 278 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toDouble(val_peek(0).sval), val_peek(0).sval); }
break;
case 117:
//#line 279 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toFloat(val_peek(0).sval), val_peek(0).sval); }
break;
case 118:
//#line 280 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toLong(val_peek(0).sval), val_peek(0).sval); }
break;
case 119:
//#line 281 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toInteger(val_peek(0).sval), val_peek(0).sval); }
break;
case 120:
//#line 282 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toBoolean(val_peek(0).sval), val_peek(0).sval); }
break;
case 121:
//#line 283 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ String s = lexer.getCodeBody(); yyval.annoval = new AnnotationConstant(toChar(s), s); }
break;
case 122:
//#line 284 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ String s = lexer.getCodeBody(); yyval.annoval = new AnnotationConstant(toString(s), s); }
break;
case 123:
//#line 287 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "boolean"; }
break;
case 124:
//#line 288 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "byte"; }
break;
case 125:
//#line 289 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "short"; }
break;
case 126:
//#line 290 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "int"; }
break;
case 127:
//#line 291 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "long"; }
break;
case 128:
//#line 292 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "char"; }
break;
case 129:
//#line 293 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "float"; }
break;
case 130:
//#line 294 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = "double"; }
break;
case 131:
//#line 300 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    	TypeDef td = val_peek(1).type;
    	td.dimensions = val_peek(0).ival;
        yyval.type = td;
    }
break;
case 132:
//#line 307 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    		TypeDef td = new TypeDef(val_peek(1).sval,0);
    		td.actualArgumentTypes = new ArrayList();
    		yyval.type = (TypeDef) typeStack.push(td);
    	}
break;
case 133:
//#line 311 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ 
    		yyval.type = (TypeDef) typeStack.pop();
    	}
break;
case 134:
//#line 313 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
         yyval.type = val_peek(1).type;
    }
break;
case 135:
//#line 316 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        yyval.type = new TypeDef(val_peek(0).sval,0); 
    }
break;
case 136:
//#line 321 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 137:
//#line 322 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).type.name + '.' + val_peek(0).sval; }
break;
case 138:
//#line 325 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 139:
//#line 326 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + '.' + val_peek(0).sval; }
break;
case 140:
//#line 329 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ ((TypeDef) typeStack.peek()).actualArgumentTypes.add(val_peek(0).type);}
break;
case 141:
//#line 330 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ ((TypeDef) typeStack.peek()).actualArgumentTypes.add(val_peek(0).type);}
break;
case 142:
//#line 333 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.type = val_peek(0).type;}
break;
case 143:
//#line 334 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef();}
break;
case 144:
//#line 335 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef(val_peek(0).type, "extends");}
break;
case 145:
//#line 336 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef(val_peek(0).type, "super");}
break;
case 148:
//#line 340 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ mth.typeParams = new ArrayList(); }
break;
case 152:
//#line 347 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ mth.typeParams.add(new TypeVariableDef(val_peek(0).sval)); }
break;
case 153:
//#line 348 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ 
      typeVariable = new TypeVariableDef(val_peek(1).sval);
      typeVariable.bounds = new ArrayList();
    }
break;
case 154:
//#line 351 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
      mth.typeParams.add(typeVariable);
      typeVariable = null;
    }
break;
case 155:
//#line 357 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ typeVariable.bounds.add(val_peek(0).type); }
break;
case 156:
//#line 358 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ typeVariable.bounds.add(val_peek(0).type); }
break;
case 157:
//#line 362 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
  builder.endClass();
  fieldType = null;
  modifiers.clear();
}
break;
case 158:
//#line 368 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
    cls.lineNumber = line;
    cls.modifiers.addAll(modifiers);
    cls.name = val_peek(1).sval;
    cls.type = ClassDef.ENUM;
    builder.beginClass(cls);
    cls = new ClassDef();
    fieldType = new TypeDef(val_peek(1).sval, 0);
}
break;
case 166:
//#line 387 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(0).sval, 0), ""); }
break;
case 167:
//#line 388 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(1).sval, 0), ""); }
break;
case 168:
//#line 389 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(1).sval, 0), ""); }
break;
case 169:
//#line 390 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(2).sval, 0), ""); }
break;
case 170:
//#line 396 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        builder.endClass(); 
    }
break;
case 171:
//#line 401 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        cls.lineNumber = line;
        cls.modifiers.addAll(modifiers); modifiers.clear(); 
        cls.name = val_peek(3).sval;
        builder.beginClass(cls); 
        cls = new ClassDef(); 
    }
break;
case 172:
//#line 410 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.type = ClassDef.CLASS; }
break;
case 173:
//#line 411 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.type = ClassDef.INTERFACE; }
break;
case 174:
//#line 412 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.type = ClassDef.ANNOTATION_TYPE; }
break;
case 177:
//#line 417 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.extendz.add(val_peek(0).type); }
break;
case 178:
//#line 418 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.extendz.add(val_peek(0).type); }
break;
case 181:
//#line 423 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.implementz.add(val_peek(0).type); }
break;
case 182:
//#line 424 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ cls.implementz.add(val_peek(0).type); }
break;
case 184:
//#line 426 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 194:
//#line 439 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
      yyval.sval = "";
    }
break;
case 195:
//#line 442 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
	  yyval.sval = lexer.getCodeBody();
    }
break;
case 196:
//#line 447 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ lexer.getCodeBody(); modifiers.clear(); }
break;
case 197:
//#line 452 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        fieldType = val_peek(1).type;
        makeField(val_peek(0).type, lexer.getCodeBody());
    }
break;
case 198:
//#line 456 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        modifiers.clear();
    }
break;
case 200:
//#line 461 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 201:
//#line 461 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        makeField(val_peek(0).type, lexer.getCodeBody());
    }
break;
case 202:
//#line 469 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.returnType = val_peek(5).type;
        mth.dimensions = val_peek(2).ival;
        mth.name = val_peek(4).sval;
        mth.body = val_peek(0).sval;
        builder.addMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 203:
//#line 479 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear();
        mth.returnType = val_peek(5).type;
        mth.dimensions = val_peek(2).ival;
        mth.name = val_peek(4).sval;
        mth.body = val_peek(0).sval;
        builder.addMethod(mth);
        mth = new MethodDef();
    }
break;
case 204:
//#line 491 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.constructor = true; mth.name = val_peek(3).sval;
        mth.body = val_peek(0).sval;
        builder.addMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 208:
//#line 505 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ mth.exceptions.add(val_peek(0).sval); }
break;
case 209:
//#line 506 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ mth.exceptions.add(val_peek(0).sval); }
break;
case 214:
//#line 515 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{
        param.name = val_peek(0).type.name;
        param.type = val_peek(2).type;
        param.dimensions = val_peek(0).type.dimensions;
        param.isVarArgs = val_peek(1).bval;
        mth.params.add(param);
        param = new FieldDef();
    }
break;
case 215:
//#line 525 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.bval = false; }
break;
case 216:
//#line 526 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ yyval.bval = true; }
break;
case 220:
//#line 531 "/scm/oss/qdox/trunk/target/checkout/src/grammar/parser.y"
{ param.modifiers.add(val_peek(0).sval); }
break;
//#line 2052 "Parser.java"
//########## END OF USER-SUPPLIED ACTIONS ##########
    }//switch
    //#### Now let's reduce... ####
    if (yydebug) debug("reduce");
    state_drop(yym);             //we just reduced yylen states
    yystate = state_peek(0);     //get new state
    val_drop(yym);               //corresponding value drop
    yym = yylhs[yyn];            //select next TERMINAL(on lhs)
    if (yystate == 0 && yym == 0)//done? 'rest' state and at first TERMINAL
      {
      if (yydebug) debug("After reduction, shifting from state 0 to state "+YYFINAL+"");
      yystate = YYFINAL;         //explicitly say we're done
      state_push(YYFINAL);       //and save it
      val_push(yyval);           //also save the semantic value of parsing
      if (yychar < 0)            //we want another character?
        {
        yychar = yylex();        //get next character
        if (yychar<0) yychar=0;  //clean, if necessary
        if (yydebug)
          yylexdebug(yystate,yychar);
        }
      if (yychar == 0)          //Good exit (if lex returns 0 ;-)
         break;                 //quit the loop--all DONE
      }//if yystate
    else                        //else not done yet
      {                         //get next state and push, for next yydefred[]
      yyn = yygindex[yym];      //find out where to go
      if ((yyn != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn]; //get new state
      else
        yystate = yydgoto[yym]; //else go to new defred
      if (yydebug) debug("after reduction, shifting from state "+state_peek(0)+" to state "+yystate+"");
      state_push(yystate);     //going again, so push state & val...
      val_push(yyval);         //for next action
      }
    }//main loop
  return 0;//yyaccept!!
}
//## end of method parse() ######################################



//## run() --- for Thread #######################################
//## The -Jnorun option was used ##
//## end of method run() ########################################



//## Constructors ###############################################
//## The -Jnoconstruct option was used ##
//###############################################################



}
//################### END OF CLASS ##############################
